<?php
// *******************************************************************
// Title          Module to report new messages in udde Instant Messages (uddeIM)
// Description    Instant Messages System for Mambo 4.5 / Joomla 1.0 / Joomla 1.5
// Author          2007-2008 Stephan Slabihoud,  2006 Benjamin Zweifel
// License        This is free software and you may redistribute it under the GPL.
//                uddeIM comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
// *******************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	require_once(JPATH_SITE.'/components/com_uddeim/uddeimlib15.php');
} else {
	global $mainframe;
	require_once($mainframe->getCfg('absolute_path').'/components/com_uddeim/uddeimlib10.php');
}

$pathtoadmin = uddeIMgetPath('admin');
$pathtouser  = uddeIMgetPath('user');
$pathtosite  = uddeIMgetPath('live_site');
$database = uddeIMgetDatabase();
$mosConfig_lang = uddeIMgetLang();

require_once($pathtouser.'/crypt.class.php');
require_once($pathtoadmin.'/config.class.php');
$config = new uddeimconfigclass();

if(!defined('_UDDEIM_INBOX')) {
	$postfix = "";
	if ($config->languagecharset)
		$postfix = ".utf8";
	if (file_exists($pathtoadmin.'/language'.$postfix.'/'.$mosConfig_lang.'.php')) {
		include_once($pathtoadmin.'/language'.$postfix.'/'.$mosConfig_lang.'.php');
	} elseif (file_exists($pathtoadmin.'/language'.$postfix.'/english.php')) {
		include_once($pathtoadmin.'/language'.$postfix.'/english.php');
	} elseif (file_exists($pathtoadmin.'/language/english.php')) {
		include_once($pathtoadmin.'/language/english.php');
	}
	$GLOBALS['udde_smon'] = $udde_smon;
	$GLOBALS['udde_lmon'] = $udde_lmon;
	$GLOBALS['udde_sweekday'] = $udde_sweekday;
	$GLOBALS['udde_lweekday'] = $udde_lweekday;
}

$par_hidenotifier = (int)$params->get( 'hidenotifier', '0' );
$par_showmsg      = (int)$params->get( 'showmsg', '1' );
$par_maxchars     = (int)$params->get( 'maxchars', '24' );
$par_manylines    = (int)$params->get( 'manylines', '5' );
$cbDHTMLPopup     = (int)$params->get( 'uddeDHTMLpopup', 1);
$cbenablepopup    = (int)$params->get( 'uddeenablepopup', 0 );
$uddeenableajax   = (int)$params->get( 'uddeenableajax', 0 );
$uddeajaxtime     = (int)$params->get( 'uddeajaxtime', 0 );
$nametype         = (int)$params->get( 'nametype', 0 );
$rightpos         = (int)$params->get( 'rightpos', '10' );
$timeout          = (int)$params->get( 'timeout', '10000' );
$rightspeed       = (int)$params->get( 'rightspeed', '20' );
$leftspeed        = (int)$params->get( 'leftspeed', '20' );

if (!$par_maxchars)		$par_maxchars = 24;
if ($par_manylines<0)	$par_manylines = 0;
if ($uddeajaxtime<5)	$uddeajaxtime = 5;

if (!is_callable("cbLoginCheckJversion")) {
	function cbLoginCheckJversion() {
		$version = uddeIMgetVersion();
		if ($version->PRODUCT == "Mambo") {
			if ( strncasecmp( $version->RELEASE, "4.6", 3 ) < 0 ) {
				$ver = 0;
			} else {
				$ver = -1;
			}
		} elseif ($version->PRODUCT == "Joomla!" || $version->PRODUCT == "Accessible Joomla!") {
			if (strncasecmp($version->RELEASE, "1.0", 3)) {
				$ver = 1;
			} else {
				$ver = 0;
			}
		}
		return $ver;
	}
}

$userid = uddeIMgetUserID();
$mygroupid = uddeIMgetGroupID();

$moduleSubPath = $pathtosite."/modules/mod_uddeim";
switch ( cbLoginCheckJversion() ) {
 	case 0:		// Mambo 4.5 & Joomla 1.0:
				$moduleSubPath = $pathtosite."/modules/mod_uddeim";
				break;
 	case -1:	// Mambo 4.6.x:
				$moduleSubPath = $pathtosite."/modules/mod_uddeim";
				break;
 	case 1:
 	default:	// Joomla 1.5+
				$moduleSubPath = $pathtosite."/modules/mod_uddeim/mod_uddeim";
				break;
}

if (!$userid) {
	if (!$par_hidenotifier) {
		echo "<div id='uddeim-module'>";
		echo "<p class='uddeim-module-head'>"._UDDEIM_NOTLOGGEDIN."</p>";
		echo "</div>";
	}
	return;
}

switch($nametype) {
	case 0 : $query = "SELECT name FROM #__users WHERE id = ". (int)$userid; break;
	case 1 : $query = "SELECT username FROM #__users WHERE id = ". (int)$userid; break;
	case 2 : if (uddeIMmodCheckCB()) {
				$query = "SELECT firstname FROM #__comprofiler WHERE id = ". (int)$userid;
			 } else {
				$query = "SELECT name FROM #__users WHERE id = ". (int)$userid; break;
			 }
			 break;
}
$database->setQuery( $query );
$name = htmlspecialchars($database->loadResult());

// first try to find a published link
$sql="SELECT id FROM #__menu WHERE link LIKE '%com_uddeim%' AND published=1 AND access".
		($mygroupid==0 ? "=" : "<=").$mygroupid." LIMIT 1";
$database->setQuery($sql);
$item_id = (int)$database->loadResult();
if (!$item_id) {
	// when no published link has been found, try to find an unpublished one
	$sql="SELECT id FROM #__menu WHERE link LIKE '%com_uddeim%' AND published=0 AND access".
			($mygroupid==0 ? "=" : "<=").$mygroupid." LIMIT 1";
	$database->setQuery($sql);
	$item_id = (int)$database->loadResult();
}
if ($config->overwriteitemid)
	$item_id = $config->useitemid;


$pms_link = uddeIMsefRelToAbs("index.php?option=com_uddeim&task=inbox".($item_id ? "&Itemid=".$item_id : ""));

$sql="SELECT a.*, b.".($config->realnames ? "name" : "username")." AS displayname FROM #__uddeim AS a LEFT JOIN #__users AS b ON a.fromid=b.id WHERE a.toread=0 AND a.totrash=0 AND a.toid=".(int)$userid." ORDER BY a.datum";
//if ($par_manylines>0) {
//	$sql.=" LIMIT ".$par_manylines;
//}
$database->setQuery($sql);
$allmessages=$database->loadObjectList();
$totalmessages=count($allmessages);

if (!$par_hidenotifier) {
	if (file_exists(uddeIMgetPath('absolute_path').'/components/com_uddeim/templates/'.$config->templatedir.'/css/uddemodule.css')) {
		echo '<link rel="stylesheet" href="'.$pathtosite.'/components/com_uddeim/templates/'.$config->templatedir.'/css/uddemodule.css" type="text/css" />';
	} elseif(file_exists(uddeIMgetPath('absolute_path').'/components/com_uddeim/templates/default/css/uddemodule.css')) {
		echo '<link rel="stylesheet" href="'.$pathtosite.'/components/com_uddeim/templates/default/css/uddemodule.css" type="text/css" />';
	}
}
$uddeicons_modulenewmess    = $pathtosite.'/components/com_uddeim/templates/'.$config->templatedir.'/images/env_ani.gif';
$uddeicons_modulenonewmess  = $pathtosite.'/components/com_uddeim/templates/'.$config->templatedir.'/images/env.gif';
$luddeicons_modulenewmess   = $pathtouser.'/templates/'.$config->templatedir.'/images/env_ani.gif';
$luddeicons_modulenonewmess = $pathtouser.'/templates/'.$config->templatedir.'/images/env.gif';

if ($cbenablepopup && $totalmessages>0) {		// NEW MESSAGES, so do notification popups when enabled
	// ALERT-POPUP-CODE ##################################################################################
	$DoAlert = 0;
	$query_popup = "SELECT popup FROM #__uddeim_emn WHERE userid=". (int)$userid;
	$database->setQuery( $query_popup );
	$dopopup = (int)$database->loadResult();
	if ($dopopup)
		$DoAlert = 1;
	// do not show popup when PMS component is active
	if (stristr($_SERVER['REQUEST_URI'],'option=com_uddeim')!==FALSE)
		$DoAlert = 0;
	if (stristr($_SERVER['REQUEST_URI'],'/uddeim')!==FALSE)
		$DoAlert = 0;
	if ( $DoAlert ) {
		// ToDo: Set flag, message has been displayed
		switch( $cbDHTMLPopup ) {
			case 1:		$message = "Hi " . $name . "<br />";
						$message .= _UDDEMODULE_YOUHAVE." ".$totalmessages." ".($totalmessages == 1 ? _UDDEMODULE_MESSAGE : _UDDEMODULE_MESSAGES);
						uddepmscalldhtml($message, $pms_link, $moduleSubPath);
						break;
			case 2:		$message = "Hi " . $name . "<br />";
						$message .= _UDDEMODULE_YOUHAVE." ".$totalmessages." ".($totalmessages == 1 ? _UDDEMODULE_MESSAGE : _UDDEMODULE_MESSAGES);
						uddepmscalldhtmlfloater($timeout, $rightpos, $rightspeed, $leftspeed, $uddeicons_modulenewmess, $message, $pms_link, $moduleSubPath);
						break;
			default:	$message .= "\\n"._UDDEMODULE_YOUHAVE." ".$totalmessages." ".($totalmessages == 1 ? _UDDEMODULE_MESSAGE : _UDDEMODULE_MESSAGES)."\\n";
						echo uddepmscalljava($message, $pms_link, $moduleSubPath);
						break;
		}
	}
}


if (!$par_hidenotifier) {
	if (class_exists('JHTML')) {
		$completeURL = "index.php?option=com_uddeim&task=ajaxGetNewMessages&no_html=1";
	} else {
		$completeURL = "index2.php?option=com_uddeim&task=ajaxGetNewMessages&no_html=1";
	}

	if ($uddeenableajax) {
		$ajaxcode = 
"<SCRIPT LANGUAGE='JavaScript'>
<!--
uddSetTimer();
function uddSetTimer() {
//	var almin = document.getElementById('refhmsg');
//	if (document.getElementById('refhmsg')!=null) {
//		min=almin*60000;
//	} else {
//		min=6000;
//	}
	var uddMin = ".$uddeajaxtime."*1000;
	var uddTimer = setInterval('uddShowUser()', uddMin);
}
var uddXMLHttp;
var uddTotal = ".$totalmessages.";
function uddShowUser() { 
	uddXMLHttp = uddGetXmlHttpObject()
	if (uddXMLHttp==null) {		// alert ('Browser does not support HTTP Request');
		return;
	}
	var uddURL = '".$completeURL."';
	uddXMLHttp.onreadystatechange = uddStateChanged;
	uddXMLHttp.open('GET',uddURL,true);
	uddXMLHttp.send(null);
}

function uddStateChanged() { 
	if (uddXMLHttp.readyState==4 || uddXMLHttp.readyState=='complete') { 
		// document.getElementById('txtHint').innerHTML=uddXMLHttp.responseText 
		var uddAllValue = uddXMLHttp.responseText;
		// chkval= AllValue.split('~');
		uddChkval = uddAllValue.split('~');
		if (uddChkval[0]!=0) {
			if (document.getElementById('nomessage'))
				document.getElementById('nomessage').innerHTML = '"._UDDEMODULE_NEWMESSAGES."'+' '+uddChkval;
			if (document.getElementById('noimage'))
				document.getElementById('noimage').src = '".$uddeicons_modulenewmess."';
		} else {
			if (document.getElementById('nomessage'))
				document.getElementById('nomessage').innerHTML = '"._UDDEMODULE_NONEW."';
			if (document.getElementById('noimage'))
				document.getElementById('noimage').src = '".$uddeicons_modulenonewmess."';
		}
		if (uddTotal!=uddChkval[0]) { ";

//			switch( $cbDHTMLPopup ) {
// trigger the event to display floater box etc. here
//			}

		$ajaxcode .= "} ";
		$ajaxcode .= "
	} 
}
function uddGetXmlHttpObject() {
	var uddXMLHttp=null;
	try {
		// Firefox, Opera 8.0+, Safari
		uddXMLHttp = new XMLHttpRequest();
	}
	catch (e) {
		// Internet Explorer
		try {
			uddXMLHttp=new ActiveXObject('Msxml2.XMLHTTP');
		}
		catch (e) {
			uddXMLHttp=new ActiveXObject('Microsoft.XMLHTTP');
		}
	}
	return uddXMLHttp;
}
//-->
</SCRIPT>";
		echo $ajaxcode;
	}

	$headline = "<a href='".$pms_link."'>"._UDDEMODULE_PRIVATEMESSAGES."</a>";

	if ($totalmessages>0) {		// NEW MESSAGES

		echo "<div id='uddeim-modulenew'>";
		echo "<p class='uddeim-module-head'>".$headline;
		if (file_exists($luddeicons_modulenewmess))
			echo " <a href='".$pms_link."'><img id='noimage' border='0' src='".$uddeicons_modulenewmess."' alt='' /></a>";
		echo "</p>";

		if (!$par_showmsg) {	// DONT SHOW NEW MESSAGES
			echo "<p class='uddeim-module-body'><a id='nomessage' href='".$pms_link."'>"._UDDEMODULE_NEWMESSAGES." ".$totalmessages."</a></p>";
		} else {				// SHOW NEW MESSAGES

			$count=1;
			foreach($allmessages as $themessage) {
				if ($count<=$par_manylines || $count==0) {
					if($themessage->systemmessage) {
						$whofrom=$themessage->systemmessage;
					} else {
						$whofrom=$themessage->displayname;
					}
					if (function_exists('bcdiv')) {
						$halfchars=bcdiv($par_maxchars,2,0);
					} elseif (function_exists('floor')) {
						$halfchars=floor($par_maxchars/2);
					} else {
						$halfchars=($par_maxchars/2);
					}
					if(strlen($whofrom)>=($halfchars-1)) {
						$whofrom=substr($whofrom, 0, ($halfchars-1));
						$whofrom=$whofrom.".";
					}

					$cm = uddeIMgetMessage($themessage->message, "", $themessage->cryptmode, "", $config->cryptkey);
					$displaymessage=stripslashes($cm);
					if($themessage->systemmessage || $config->allowbb) {					
						require_once ($pathtouser."/bbparser.php");
						$displaymessage=uddeIMbbcode_strip($displaymessage);
					}
					$displaymessage=htmlspecialchars($displaymessage, ENT_QUOTES, $config->charset);
					$displaymessage=str_replace("&amp;#", "&#", $displaymessage); 

					$maxlen=$par_maxchars-strlen($whofrom)-1;	// one space
					if($maxlen<5)
						$maxlen=5;

					if ($themessage->cryptmode==2) {
						$pms_show = uddeIMsefRelToAbs("index.php?option=com_uddeim".($item_id ? "&Itemid=".$item_id : "")."&task=showpass&messageid=".$themessage->id);
					} else {
						$pms_show = uddeIMsefRelToAbs("index.php?option=com_uddeim".($item_id ? "&Itemid=".$item_id : "")."&task=show&messageid=".$themessage->id);
					}
					if ($par_showmsg==2) {
						echo "<p class='uddeim-module-row'>";
						echo "<a href='".$pms_show."'>".$whofrom."</a>";
						echo "</p>";
					} else {
						echo "<p class='uddeim-module-row'>".$whofrom." ";
						echo "<a href='".$pms_show."'>".teaser_head($displaymessage, $maxlen)."</a>";
						echo "</p>";
					}
				}
				$count++;
			}
		}
		echo "</div>";			// uddeim-modulenew
	} else {					// NO NEW MESSAGES

		echo "<div id='uddeim-module'>";
		echo "<p class='uddeim-module-head'>".$headline;
		if (file_exists($luddeicons_modulenonewmess))
			echo " <a href='".$pms_link."'><img id='noimage' border='0' src='".$uddeicons_modulenonewmess."' alt='' /></a>";
		echo "</p>";
		echo "<p id='nomessage' class='uddeim-module-body'>"._UDDEMODULE_NONEW."</p>";
		echo "</div>";	  

	}
}

function uddeIMmodCheckCB() {
	$pathtocb = uddeIMgetPath('absolute_path')."/components/com_comprofiler/comprofiler.php";
	if (file_exists($pathtocb))
		return true;
	return false;
}
  
function teaser_head($ofwhat, $howlong) {
	$msgparts=explode("__________", $ofwhat, 2);

	$words=explode(" ", $msgparts[0]);
	$howmanywords=count($words);

	$x=0;
	if (!$howlong) { $howlong=33; }
	$trailstring="";
	if (strlen($msgparts[0])>$howlong) {
		$howlong=$howlong-3;
		$trailstring="...";
	}
	$construct="";
	// while ((strlen($construct)+strlen($words[$x]))<=$howlong):
	//		$construct.=" ".$words[$x];
	// $x++;
	// endwhile;
	if(strlen($words[0])>$howlong) {
		$construct=substr($words[0], 0, ($howlong-3));
	} else {		
		for($x=0; $x < $howmanywords; $x++) {
			$posslen=strlen($construct)+strlen($words[$x]);
			if($posslen<=$howlong) {
				$construct.=" ".$words[$x];
			} else {
				break;
			}
		}
	}
	$construct.=$trailstring;
	$construct=ltrim($construct);
	if(empty($construct)) {
		$construct="...";
	}	
	return $construct;
}

// Popup-Code
function uddepmscalljava($message,$pms_link,$moduleSubPath){
	$javawindow = "<script language=\"Javascript\">"
	. "alert(\"$message\")"
	. "</script>";
	return $javawindow;
}

function uddepmscalldhtml($message, $pms_link, $moduleSubPath){
	$link = '<a href="'.$pms_link.'"><div style="text-align: justify; padding: 2px 5px; font-size: 13px; font-family: Arial; width: 250px; background-color: #FFFFFF; color: #000000;">'.$message.'</div></a>';
//	$link = '<div style="text-align: justify; padding: 2px 5px; font-size: 13px; font-family: Arial; background-color: #FFFFFF; color: #000000;">'.$message.'</div>';
        $title = _UDDEMODULE_EXPRESSMESSAGE;
        //$title = "<img src=\"$mosConfig_live_site/modules/mod_uddeim/close.gif\" style=\"vertical-align: bottom;\" width=\"16\" height=\"14\" />".$title;
	echo "<link href=\"".$moduleSubPath."/popup.css\" rel=\"stylesheet\" type=\"text/css\" />\n";
	echo "<script language=\"Javascript\" src=\"".$moduleSubPath."/domLib.js\"></script>\n"
		. "<script language=\"Javascript\" src=\"".$moduleSubPath."/domTT.js\"></script>\n"
		. "<script language=\"Javascript\" src=\"".$moduleSubPath."/domTT_drag.js\"></script>\n"
		. "<script type=\"text/javascript\" language=\"javascript\"><!--\n"
		. "	var domTT_styleClass = 'domTTWin';\n"
		. "	var domTT_draggable = true;\n"
		. "	var domTT_closeLink = '<img src=\"".$moduleSubPath."/close.gif\" style=\"vertical-align: bottom;\" width=\"16\" height=\"14\" alt=\"\" />';\n"
		. "	window.onload = function(in_event) {\n"
		. "	  domTT_addPredefined('popup', 'caption', '$title', 'content', '$link', 'type', 'sticky');\n"
		. "	  domTT_activate('popup1', in_event, 'predefined', 'popup', 'x', 400, 'y', 150, 'delay', 200 );\n"	// 'width', 273, 
		. "	};\n"
		. "	window.onmousemove = function(in_event) {};\n"	// compatibility fix for overlib_mini.js
		. "-->\n"
		. "</script>\n";
}

function uddepmscalldhtmlfloater($timeout, $rightpos, $rightspeed, $leftspeed, $uddeicons_modulenewmess, $message, $pms_link, $moduleSubPath){
	$link = "<a href='".$pms_link."'>".$message."</a>";
	echo "<link href='".$moduleSubPath."/popupex.css' rel='stylesheet' type='text/css' />\n";
	echo "<div style='left: -450px;' id='floaterDiv' class='floaterTranslucent'>";
	  echo "<div class='floaterTitle'>"._UDDEMODULE_EXPRESSMESSAGE;
	  echo "<a href='javascript:floatOut()'><img src='".$moduleSubPath."/close.gif' border='0' alt='' /></a>";
	  echo "</div>";
	  echo "<div class='floaterBody'><br />".$link."<br /><br /><img src='".$moduleSubPath."/mail.gif' border='0' alt='' /></div>\n";
	echo "</div>\n";
?>
<script language="JavaScript" type="text/javascript"><!--
function floatIn() {
	if (document.getElementById) {
		if (parseInt(obj.style["left"]) <  rightpos) {
			obj.style["left"] = parseInt(obj.style["left"]) + 20 + "px";
			setTimeout("floatIn()", <?php echo $rightspeed; ?>);
		}
	}
}

function floatOut() {
	if (document.getElementById) {
		if (parseInt(obj.style["left"]) > -450) {
			obj.style["left"] = parseInt(obj.style["left"]) - 20 + "px";
			setTimeout("floatOut()", <?php echo $leftspeed; ?>);
		} else {
			obj.style.visibility = "hidden";
		}
	}
}

function start() {
	if (document.getElementById) {
		obj = document.getElementById("floaterDiv");
		obj.style["left"] = "-450px";
		obj.style.visibility = "visible";
	}
	floatIn();
}

var rightpos = <?php echo $rightpos; ?>;
if (document.getElementById) {
	if (rightpos<0) {
		rightpos = document.body.clientWidth + rightpos;
	}
}

setTimeout('floatOut();', <?php echo $timeout; ?>);
window.onload = start;
-->
</script>
<?php
}
