<?php
// *******************************************************************
// Title          Module to show mailbox status in udde Instant Messages (uddeIM)
// Description    Instant Messages System for Mambo 4.5 / Joomla 1.0 / Joomla 1.5
// Author          2007-2008 Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddeIM comes with absolutely no warranty.
//                Use at your own risk. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                Other licenses can be found in LICENSES folder.
// *******************************************************************

if (!(defined('_JEXEC') || defined('_VALID_MOS'))) { die( 'Direct Access to this location is not allowed.' ); }

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	require_once(JPATH_SITE.'/components/com_uddeim/uddeimlib15.php');
} else {
	global $mainframe;
	require_once($mainframe->getCfg('absolute_path').'/components/com_uddeim/uddeimlib10.php');
}

$pathtoadmin = uddeIMgetPath('admin');
$pathtouser  = uddeIMgetPath('user');
$pathtosite  = uddeIMgetPath('live_site');
$database = uddeIMgetDatabase();
$mosConfig_lang = uddeIMgetLang();

require_once($pathtouser.'/crypt.class.php');
require_once($pathtoadmin.'/config.class.php');
$config = new uddeimconfigclass();

if(!defined('_UDDEIM_INBOX')) {
	$postfix = "";
	if ($config->languagecharset)
		$postfix = ".utf8";
	if (file_exists($pathtoadmin.'/language'.$postfix.'/'.$mosConfig_lang.'.php')) {
		include_once($pathtoadmin.'/language'.$postfix.'/'.$mosConfig_lang.'.php');
	} elseif (file_exists($pathtoadmin.'/language'.$postfix.'/english.php')) {
		include_once($pathtoadmin.'/language'.$postfix.'/english.php');
	} elseif (file_exists($pathtoadmin.'/language/english.php')) {
		include_once($pathtoadmin.'/language/english.php');
	}
	$GLOBALS['udde_smon'] = $udde_smon;
	$GLOBALS['udde_lmon'] = $udde_lmon;
	$GLOBALS['udde_sweekday'] = $udde_sweekday;
	$GLOBALS['udde_lweekday'] = $udde_lweekday;
}

$shownew		= $params->get( 'shownew', 1 );
$showinbox		= $params->get( 'showinbox', 1 );
$showoutbox		= $params->get( 'showoutbox', 1 );
$showtrashcan	= $params->get( 'showtrashcan', 1 );
$showarchive	= $params->get( 'showarchive', 1 );
$showsettings	= $params->get( 'showsettings', 1 );
$showcompose	= $params->get( 'showcompose', 1 );
$showicons		= $params->get( 'showicons', 0 );

$userid = uddeIMgetUserID();
$mygroupid = uddeIMgetGroupID();

if (!$userid) {
	echo "<div id='uddeim-module'>";
	echo "<p class='uddeim-module-head'>"._UDDEIM_NOTLOGGEDIN."</p>";
	echo "</div>";
	return;
}

// first try to find a published link
$sql="SELECT id FROM #__menu WHERE link LIKE '%com_uddeim%' AND published=1 AND access".
		($mygroupid==0 ? "=" : "<=").$mygroupid." LIMIT 1";
$database->setQuery($sql);
$item_id = (int)$database->loadResult();
if (!$item_id) {
	// when no published link has been found, try to find an unpublished one
	$sql="SELECT id FROM #__menu WHERE link LIKE '%com_uddeim%' AND published=0 AND access".
			($mygroupid==0 ? "=" : "<=").$mygroupid." LIMIT 1";
	$database->setQuery($sql);
	$item_id = (int)$database->loadResult();
}
if ($config->overwriteitemid)
	$item_id = $config->useitemid;

$out = "<div id='uddeim-module'>";

if ( $shownew ) {
	$sql="SELECT count(a.id) FROM #__uddeim AS a WHERE a.totrash=0 AND a.toread=0 AND a.toid=".(int)$userid;
//	$sql="SELECT count(a.id) FROM #__uddeim AS a LEFT JOIN #__users AS b ON a.fromid=b.id WHERE a.totrash=0 AND a.toread=0 AND a.toid=".(int)$userid;
	$database->setQuery($sql);
	$result=(int)$database->loadResult();
	if ($result>0) {
		$out .= "<p class='uddeim-module-head'>";
		$out .= _UDDEMODULE_NEWMESSAGES." ".$result;
		$out .= "</p>";
	}
}

if ( $showinbox ) {
	$sql="SELECT count(a.id) FROM #__uddeim AS a WHERE a.totrash=0 AND archived=0 AND a.toid=".(int)$userid;
//	$sql="SELECT count(a.id) FROM #__uddeim AS a LEFT JOIN #__users AS b ON a.fromid=b.id WHERE a.totrash=0 AND archived=0 AND a.toid=".(int)$userid;
	$database->setQuery($sql);
	$result=(int)$database->loadResult();

	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_inbox.gif' alt='"._UDDEIM_INBOX."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=inbox".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_INBOX.'">';
	$out .= _UDDEIM_INBOX.": ".$result;
	$out .= '</a>';
	$out .= "</p>";
}

if ( $showoutbox ) {
	$sql="SELECT count(a.id) FROM #__uddeim AS a WHERE a.totrashoutbox=0 AND ((a.systemmessage IS NULL) OR (a.systemmessage='')) AND a.fromid=".(int)$userid;
//	$sql="SELECT count(a.id) FROM #__uddeim AS a LEFT JOIN #__users AS b ON a.toid=b.id WHERE a.totrashoutbox=0 AND ((a.systemmessage IS NULL) OR (a.systemmessage='')) AND a.fromid=".(int)$userid;
	$database->setQuery($sql);
	$result=(int)$database->loadResult();

	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_outbox.gif' alt='"._UDDEIM_OUTBOX."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=outbox".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_OUTBOX.'">';
	$out .= _UDDEIM_OUTBOX.": ".$result;
	$out .= '</a>';
	$out .= "</p>";
}

if ( $showtrashcan ) {
	$rightnow=moduddemailboxtime((int)$config->timezone);
	$offset=((float)$config->TrashLifespan) * 86400;
	$timeframe=$rightnow-$offset;

	$sql="SELECT count(id) FROM #__uddeim WHERE (totrashdate>=".$timeframe." AND toid=".(int)$userid." AND totrash=1) OR (totrashdateoutbox>=".$timeframe." AND fromid=".(int)$userid." AND totrashoutbox=1 AND toid<>".(int)$userid." AND ((systemmessage IS NULL) OR (systemmessage='')))";
//	$sql="SELECT count(id) FROM #__uddeim WHERE (totrashdate>=".$timeframe." AND toid=".(int)$userid." AND totrash=1) OR (totrashdateoutbox>=".$timeframe." AND fromid=".(int)$userid." AND totrashoutbox=1 AND toid<>fromid AND ((systemmessage IS NULL) OR (systemmessage='')))";
	$database->setQuery($sql);
	$result=(int)$database->loadResult();

	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_trashcan.gif' alt='"._UDDEIM_TRASHCAN."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=trashcan".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_TRASHCAN.'">';
	$out .= _UDDEIM_TRASHCAN.": ".$result;
	$out .= '</a>';
	$out .= "</p>";
}

if ( $showarchive && $config->allowarchive) {
	$sql="SELECT count(a.id) FROM #__uddeim AS a WHERE a.totrash=0 AND archived=1 AND a.toid=".(int)$userid;
//	$sql="SELECT count(a.id) FROM #__uddeim AS a LEFT JOIN #__users AS b ON a.fromid=b.id WHERE a.totrash=0 AND archived=1 AND a.toid=".(int)$userid;
	$database->setQuery($sql);
	$result=(int)$database->loadResult();

	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_archive.gif' alt='"._UDDEIM_ARCHIVE."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=archive".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_ARCHIVE.'">';
	$out .= _UDDEIM_ARCHIVE.": ".$result;
	$out .= '</a>';
	$out .= "</p>";
}

if ( $showsettings ) {
	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_settings.gif' alt='"._UDDEIM_SETTINGS."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=settings".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_SETTINGS.'">';
	$out .= _UDDEIM_SETTINGS;
	$out .= '</a>';
	$out .= "</p>";
}

if ( $showcompose ) {
	$out .= "<p class='uddeim-module-body'>";
	if($showicons)
		$out .= "<img src='".$pathtosite."/components/com_uddeim/templates/".$config->templatedir."/images/menu_new.gif' alt='"._UDDEIM_COMPOSE."' /> ";
	$out .= '<a href="'.uddeIMsefRelToAbs( "index.php?option=com_uddeim&task=new".($item_id ? "&Itemid=".$item_id : "") ).'" title="'._UDDEIM_COMPOSE.'">';
	$out .= _UDDEIM_COMPOSE;
	$out .= '</a>';
	$out .= "</p>";
}

$out .= "</div>";

echo $out;

function moduddemailboxtime($timezone = 0) {
	$mosConfig_offset = uddeIMgetOffset();
	$rightnow=time()+(($mosConfig_offset+$timezone)*3600);
	return $rightnow;
}
